#include "pt23.h"

char tab_n[][4]={"---","c-1","c#1","d-1","d#1","e-1","f-1","f#1","g-1","g#1","a-1","a#1","b-1",
                 "c-2","c#2","d-2","d#2","e-2","f-2","f#2","g-2","g#2","a-2","a#2","b-2",
                 "c-3","c#3","d-3","d#3","e-3","f-3","f#3","g-3","g#3","a-3","a#3","b-3","???"};

int tab_h[]={0,856,808,762,720,678,640,604,570,538,508,480,453,
               428,404,381,360,339,320,302,285,269,254,240,226, 
               214,202,190,180,170,160,151,143,135,127,120,113};


int vucolors[48]={0xff0000,0xff0000,0xff1100,0xff1100,0xff2200,0xff2200,0xff3300,0xff3300,
                  0xff4400,0xff5500,0xff6600,0xff7700,0xff8800,0xff9900,0xffaa00,0xffbb00,
                  0xffcc00,0xffdd00,0xffee00,0xffff00,0xffff00,0xeeff00,0xeeff00,0xddff00,
                  0xddff00,0xccff00,0xccff00,0xbbff00,0xbbff00,0xaaff00,0x99ff00,0x99ff00,
                  0x88ff00,0x88ff00,0x77ff00,0x77ff00,0x66ff00,0x66ff00,0x55ff00,0x55ff00,
                  0x44ff00,0x44ff00,0x33ff00,0x33ff00,0x22ff00,0x11ff00,0x00ff00,0x00ee00};

typedef struct
{
  int x1,y1,x2,y2;
} pt_button_s;

enum ptbuttons
{
  PTB_SUREY,PTB_SUREN,
  PTB_PLAY,PTB_PATTERN,PTB_EDIT,PTB_RECORD,
  PTB_STOP,PTB_CLEAR,PTB_EDITOP,PTB_DISKOP,
  PTB_PLST,PTB_PSETED,PTB_SETUP,PTB_SAMPLER,
  PTB_CHAN1,PTB_CHAN2,PTB_CHAN3,PTB_CHAN4,
  PTB_POSS,PTB_POSU,PTB_POSD,
  PTB_PATTERNS,PTB_PATTERNU,PTB_PATTERND,
  PTB_PLENGTHS,PTB_PLENGTHU,PTB_PLENGTHD,
  PTB_FTUNES,PTB_FTUNEU,PTB_FTUNED,
  PTB_SAMPLES,PTB_SAMPLEU,PTB_SAMPLED,
  PTB_SVOLUMES,PTB_SVOLUMEU,PTB_SVOLUMED,
  PTB_SLENGTHS,PTB_SLENGTHU,PTB_SLENGTHD,
  PTB_SREPEATS,PTB_SREPEATU,PTB_SREPEATD,
  PTB_SREPLENS,PTB_SREPLENU,SREPLEND,
  PTB_TEMPOU,PTB_TEMPOD,

  PTB_NUMBUTTONS
};




pt_button_s ptbutton[]=
{
  {171, 71,196, 81},{234, 71,252,81},
  {120,  0,181, 10},{120, 11,181, 21},{120, 21,181, 32},{120, 33,181, 43},
  {182,  0,243, 10},{182, 11,243, 21},{182, 21,243, 32},{182, 33,243, 43},
  {244,  0,305, 10},{244, 11,305, 21},{244, 21,305, 32},{244, 33,305, 43},
  {306,  0,319, 10},{306, 11,319, 21},{306, 21,319, 32},{306, 33,319, 43},
  { 62,  0, 97, 10},{ 98,  0,108, 10},{109,  0,119, 10},
  { 62, 11, 97, 21},{ 98, 11,108, 21},{109, 11,119, 21},
  { 62, 22, 97, 32},{ 98, 22,108, 32},{109, 22,119, 32},
  { 62, 33, 97, 43},{ 98, 33,108, 43},{109, 33,119, 43},
  { 62, 44, 97, 54},{ 98, 44,108, 54},{109, 44,119, 54},
  { 62, 55, 97, 65},{ 98, 55,108, 65},{109, 55,119, 65},
  { 62, 66, 97, 76},{ 98, 66,108, 76},{109, 66,119, 76},
  { 62, 77, 97, 87},{ 98, 77,108, 87},{109, 77,119, 87},
  { 62, 88, 97, 98},{ 98, 88,108, 98},{109, 88,119, 98},
  { 26,122, 44,136},{ 45,122, 59,136}

};


void pt_drawsure(unsigned char *vmem,pt23_struct *pt)
{
  int x,y;
  int ox=160;
  int oy=51;
  int o,ov;
  for(y=0;y<pt->ptsure_tga->size_y;y++)
    for(x=0;x<pt->ptsure_tga->size_x;x++)
    {
      ov=(320*(y+oy)+(x+ox))*3;
      o=(y*pt->ptsure_tga->size_x+x)*3;
      vmem[ov+0]=pt->ptsure_tga->data[o+0];
      vmem[ov+1]=pt->ptsure_tga->data[o+1];
      vmem[ov+2]=pt->ptsure_tga->data[o+2];
    }
}

int pt_checkbutton(int mx,int my,int b)
{
  if(mx>=ptbutton[b].x1 && mx<=ptbutton[b].x2 && my>=ptbutton[b].y1 && my<=ptbutton[b].y2)
    return 1;
  else
    return 0;
}

int pt_checkbuttons(pt23_struct *pt)
{
  int i=0;
  int b=-1;

  if(pt->lmb<150 && pt->lmb!=1) return -1;
  if(pt->lmb!=1)
    if(pt->lmb%25!=0) return -1;

  if(pt->mx==0 && pt->my==0) {pt->quit=1;return -1;}

  if(pt->quit==1)
  {
    if(pt_checkbutton(pt->mx,pt->my,PTB_SUREY)!=0)
      pt->quit=2;
    if(pt_checkbutton(pt->mx,pt->my,PTB_SUREN)!=0)
      pt->quit=0;
    return -1;
  }


  do
  {
      if (pt_checkbutton(pt->mx,pt->my,i)!=0)
        b=i;
    i++;
  } while(i<PTB_NUMBUTTONS && b==-1);

  return b;
}


pt23_struct *pt23_init(void)
{
  pt23_struct *pt=0;


  pt=(pt23_struct *)calloc(1,sizeof(pt23_struct));
  pt->pt_tga=Load_TGA("data/pt2.png");
  pt->ptfont_tga=Load_TGA("data/ptfont.png");
  pt->ptpnt_tga=Load_TGA("data/pnt2.png");
  pt->ptdisk_tga=Load_TGA("data/ptdisk2.png");
  pt->ptsure_tga=Load_TGA("data/ptsure.png");

  if(pt->pt_tga==0 || pt->ptfont_tga==0 || pt->ptpnt_tga==0 || pt->ptdisk_tga==0 || pt->ptsure_tga==0)
  {
    pt23_free(pt);
    return 0;
  }

  pt->sample=1;
  return pt;
}

void pt23_free(pt23_struct *pt)
{
  if(pt==0) return;
  Free_TGA(pt->pt_tga);
  Free_TGA(pt->ptfont_tga);
  Free_TGA(pt->ptpnt_tga);
  Free_TGA(pt->ptdisk_tga);
  Free_TGA(pt->ptsure_tga);
  free(pt);
}

void pt23_drawmain_sample(unsigned char *vmem,pt_mod_s *ptmod,pt23_struct *pt)
{
  int i;
  signed char ch;
  char str[256];


  for(i=0;i<22;i++)
  {
    ch=ptmod->sample[pt->sample].name[i];
    if(ch!=0)
      prntchr(104+(i*8),113,ch,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
    else
      prntchr(104+(i*8),113,'_',0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  }

  sprintf(str,"%04x",pt->sample);
  prntstr(64,47,str,0,0x000000,pt->ptfont_tga->data,vmem);
  sprintf(str,"%04x",ptmod->sample[pt->sample].volume);
  prntstr(64,58,str,0,0x000000,pt->ptfont_tga->data,vmem);
  sprintf(str,"%04x",ptmod->sample[pt->sample].length>>14);
  prntstr(64,69,str,0,0x000000,pt->ptfont_tga->data,vmem);
  sprintf(str,"%04x",ptmod->sample[pt->sample].repeat>>14);
  prntstr(64,80,str,0,0x000000,pt->ptfont_tga->data,vmem);
  sprintf(str,"%04x",ptmod->sample[pt->sample].replen>>14);
  prntstr(64,91,str,0,0x000000,pt->ptfont_tga->data,vmem);

  i=ptmod->sample[pt->sample].ft;
  ch='+';
  if(i>8){
    ch='-';
    i=(8-(i-8));
  }
  if(i==0) ch=' ';
  sprintf(str,"%x",i);
  prntstr(88,36,str,0,0x000000,pt->ptfont_tga->data,vmem);
  prntchr(80,36,ch,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
}



void pt23_drawmain(unsigned char *vmem,pt_mod_s *ptmod,pt23_struct *pt)
{
  pt_pattern_s *pat;
  int h,i,j,k,l,m;
  char str[256];
  char ch;
  int avgvol[4];
  pt_sample_s *sampl;

  memcpy(vmem,pt->pt_tga->data,320*255*3);
  //pset(mx,my,0xf0d000,vmem);
  prntchr(pt->mx,pt->my,'0',0,0x00ff00,(unsigned char *)pt->ptfont_tga->data,vmem);
  //prntstr(8,203,"01 ---00000 ---00000 ---00000 ---00000",(unsigned char *)ptfont_tga->data,vmem);


  sprintf(str,"%04d",ptmod->spos);
  prntstr(64,3,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);

  sprintf(str,"%04d",ptmod->pos[ptmod->spos]);
  prntstr(64,14,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  sprintf(str,"%02d",ptmod->pos[ptmod->spos]);
  prntstr(8,127,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);

  sprintf(str,"%04d",ptmod->length);
  prntstr(64,25,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);

  //32,123

  sprintf(str,"%03d",ptmod->ciaspeed);
  prntstr(32,123,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);

  //272 102
  i=(int)(pt->time)%60;
  j=(int)(pt->time)/60;
  sprintf(str,"%02d %02d",j,i);
  prntstr(272,102,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  for(i=0;i<20;i++)
  {
    ch=ptmod->name[i];
    if(ch!=0) 
      prntchr(104+(i*8),102,ch,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
    else
      prntchr(104+(i*8),102,'_',0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  }
  //prntstr(104,102,ptmod->name,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  
  pt23_drawmain_sample(vmem,ptmod,pt);
  //prntstr(104,113,ptmod->sample[1].name,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);

  j=0;
  //glBegin(GL_LINES);
  for(m=0;m<4;m++)
  {
    avgvol[m]=0;
    for(i=0;i<40;i++)
    {
      //j=(int)((float)i*fl);
      k=ptmod->chan[m].sp;
      l=-1;
      if(ptmod->chan[m].sample!=0)
      {
        sampl=&ptmod->sample[ptmod->chan[m].sample];
        if(k>=0 && k < sampl->length)
        {
          l=k+(i<<14);
          if (sampl->replen > 32768)
          {
            if (l >= sampl->repend)
              l -= sampl->replen;
          }
          else
          {
            if (l >= sampl->length)
              l=-1;
          }
        }
      }
      if(l==-1)
        h=0;
      else
        h=(sampl->data[l>>14]*ptmod->chan[m].vol)>>6;
      if(abs(h)>avgvol[m]) avgvol[m]=abs(h);
      //167 128,71
      pset(128+(m*48)+i,71+(h/8),0xf0d000,vmem);

      //glVertex2f(i-1,220+(j));
      //glVertex2f(i,220+(h));
      j=h;
    }
    //avgvol[m]/=40;
  }


  //95,205
   pat=&ptmod->pattern[ptmod->pos[ptmod->cspos]];
  k=ptmod->cppos;
  j=k;
  sprintf(str,"%02d %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x",j,
    getname(pat->data[j][0].period),pat->data[j][0].sample,
    pat->data[j][0].effect,pat->data[j][0].efd1,pat->data[j][0].efd2,
    getname(pat->data[j][1].period),pat->data[j][1].sample,
    pat->data[j][1].effect,pat->data[j][1].efd1,pat->data[j][1].efd2,
    getname(pat->data[j][2].period),pat->data[j][2].sample,
    pat->data[j][2].effect,pat->data[j][2].efd1,pat->data[j][2].efd2,
    getname(pat->data[j][3].period),pat->data[j][3].sample,
    pat->data[j][3].effect,pat->data[j][3].efd1,pat->data[j][3].efd2);
  prntstr(8,190,str,1,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);

  for(i=0;i<7;i++)
  {
    j=k-(7-i);
    if(j>=0 && j<64)
    {
      sprintf(str,"%02d %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x",j,
        getname(pat->data[j][0].period),pat->data[j][0].sample,
        pat->data[j][0].effect,pat->data[j][0].efd1,pat->data[j][0].efd2,
        getname(pat->data[j][1].period),pat->data[j][1].sample,
        pat->data[j][1].effect,pat->data[j][1].efd1,pat->data[j][1].efd2,
        getname(pat->data[j][2].period),pat->data[j][2].sample,
        pat->data[j][2].effect,pat->data[j][2].efd1,pat->data[j][2].efd2,
        getname(pat->data[j][3].period),pat->data[j][3].sample,
        pat->data[j][3].effect,pat->data[j][3].efd1,pat->data[j][3].efd2);
      prntstr(8,140+(i*7),str,0,0x3040f0,(unsigned char *)pt->ptfont_tga->data,vmem);
    }
    j=k+i+1;
    if(j>=0 && j<64)
    {
      sprintf(str,"%02d %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x",j,
        getname(pat->data[j][0].period),pat->data[j][0].sample,
        pat->data[j][0].effect,pat->data[j][0].efd1,pat->data[j][0].efd2,
        getname(pat->data[j][1].period),pat->data[j][1].sample,
        pat->data[j][1].effect,pat->data[j][1].efd1,pat->data[j][1].efd2,
        getname(pat->data[j][2].period),pat->data[j][2].sample,
        pat->data[j][2].effect,pat->data[j][2].efd1,pat->data[j][2].efd2,
        getname(pat->data[j][3].period),pat->data[j][3].sample,
        pat->data[j][3].effect,pat->data[j][3].efd1,pat->data[j][3].efd2);
      prntstr(8,203+(i*7),str,0,0x3040f0,(unsigned char *)pt->ptfont_tga->data,vmem);
    }

    //prntstr(8,203+(i*7),str,0,0x3040f0,(unsigned char *)ptfont_tga->data,vmem);
  }

  drawvumeter(avgvol[0]/2.6,avgvol[1]/2.6,avgvol[2]/2.6,avgvol[3]/2.6,vmem);
  //for(i=0;i<10;i++)
  //  for(j=0;j<avgvol[0]/2.6;j++)
  //    pset(55+i,187-j,vucolors[47-j],vmem);


  //
  sprintf(str,"%6d",pt->modsize);
  prntstr(264,123,str,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);


  if(pt->mb & 1)
    pt->lmb++;
  else
    pt->lmb=0;

  if(pt->mb & 2)
    pt->rmb++;
  else
    pt->rmb=0;



  pt->b=pt_checkbuttons(pt);

  switch(pt->b)
  {
  case PTB_DISKOP:
    pt->mode=1;
    break;
  case PTB_SAMPLEU:
    pt->sample++;
    if(pt->sample>31) pt->sample=31;
    break;
  case PTB_SAMPLED:
      pt->sample--;
      if(pt->sample<1) pt->sample=1;
      break;
  case PTB_POSU:
    ptmod->spos++;
    if(ptmod->spos>127) ptmod->spos=127;
    break;
  case PTB_POSD:
    ptmod->spos--;
    if(ptmod->spos<0) ptmod->spos=0;
    break;
  case PTB_TEMPOU:
    if(pt->rmb!=0) ptmod->ciaspeed+=10; else ptmod->ciaspeed++;
    if(ptmod->ciaspeed>255) ptmod->ciaspeed=255;
    ptmod->vbllen=ptmod->freq * 60 / (24 * ptmod->ciaspeed);
    break;
  case PTB_TEMPOD:
    if(pt->rmb!=0) ptmod->ciaspeed-=10; else ptmod->ciaspeed--;
    if(ptmod->ciaspeed<32) ptmod->ciaspeed=32;
    ptmod->vbllen=ptmod->freq * 60 / (24 * ptmod->ciaspeed);
    break;
  case PTB_PLAY:
    ptmod->state=PT_STATE_PLAYSONG;
    ptmod->ppos=0;
    break;
  case PTB_STOP:
    ptmod->state=PT_STATE_STOP;
    for(i=0;i<4;i++)
    {
      ptmod->chan[i].sample=0;
    }
    break;
  case PTB_PATTERN:
    ptmod->state=PT_STATE_PLAYPATTERN;
    break;
  };

  if(pt->mode==1)
  {
    memcpy(vmem,pt->ptdisk_tga->data,320*99*3);
  }

  if(pt->quit==1)
    pt_drawsure(vmem,pt);


  // quit req 160,51

  drawpnt(pt->mx,pt->my,pt->ptpnt_tga->data,vmem);
}

void prntchr(int x,int y,char c,int s,int rgb,unsigned char *font,unsigned char *vmem)
{
  int o;
  int ox,oy;
  int xx,yy;
  int r,g,b;
  if(c>96) c-=32;
  o=c-32;
  if(o<0 || o>71) return;
  o*=8;
  if(x<0 || y<0 || x>312 || y>247) return;
  if(s==1 && y>239) return;
  r=(rgb>>16)&0xff;
  g=(rgb>>8)&0xff;
  b=(rgb)&0xff;
  for(yy=0;yy<8;yy++)
    for(xx=0;xx<8;xx++)
    {
      ox=xx+x;
      oy=yy+y;
      if(s==1){oy=yy*2+y;}
      if(font[((o+yy)*8+xx)*4]!=0)
      {
        if(s==1)
        {
          vmem[(oy*320+ox)*3+0]=r;
          vmem[(oy*320+ox)*3+1]=g;
          vmem[(oy*320+ox)*3+2]=b;
          vmem[((oy+1)*320+ox)*3+0]=r;
          vmem[((oy+1)*320+ox)*3+1]=g;
          vmem[((oy+1)*320+ox)*3+2]=b;
        }
        else
        {
          vmem[(oy*320+ox)*3+0]=r;
          vmem[(oy*320+ox)*3+1]=g;
          vmem[(oy*320+ox)*3+2]=b;
        }
      }

    }
}

void drawpnt(int x,int y,unsigned char *p,unsigned char *vmem)
{
  int xx,yy;
  int ox,oy;
  for(yy=0;yy<16;yy++)
    for(xx=0;xx<16;xx++)
    {
      ox=xx+x;
      oy=yy+y;
      if(ox>=0 && ox<=319 && oy>=0 && oy<=254)
      {
        if(p[(yy*16+xx)*3+0]!=0)
        {
          vmem[(oy*320+ox)*3+0]=p[(yy*16+xx)*3+0];
          vmem[(oy*320+ox)*3+1]=p[(yy*16+xx)*3+1];
          vmem[(oy*320+ox)*3+2]=p[(yy*16+xx)*3+2];
        }
      }

    }



}
void prntstr (int x,int y,char *str,int s,int rgb,unsigned char *font,unsigned char *vmem)
{
  int l;
  int i;

  l=strlen(str);
  for(i=0;i<l;i++)
    prntchr(x+(i*8),y,str[i],s,rgb,font,vmem);
}
void pset(int x,int y,int rgb,unsigned char *vmem)
{
  unsigned char r,g,b;
  r=(rgb>>16)&0xff;
  g=(rgb>>8)&0xff;
  b=(rgb)&0xff;

  vmem[(y*320+x)*3+0]=r;
  vmem[(y*320+x)*3+1]=g;
  vmem[(y*320+x)*3+2]=b;
}

void drawvumeter(int v1,int v2,int v3,int v4,unsigned char *vmem)
{
  int r,g,b;
  int rgb;
  int rgb1,rgb2;
  int vu[4];
  int c,o;
  int x,y;

  vu[0]=v1;vu[1]=v2;vu[2]=v3;vu[3]=v4;

  //55+72*i;
  for(c=0;c<4;c++)
  {
    o=55+72*c;
    for(y=0;y<vu[c];y++)
    {
      rgb=vucolors[47-y];
      r=(rgb>>16)&0xff;
      g=(rgb>>8)&0xff;
      b=(rgb)&0xff;
      r+=0x33;g+=0x33;b+=0x33;
      if(r>0xff) r=0xff;
      if(g>0xff) g=0xff;
      if(b>0xff) b=0xff;
      rgb1=(r<<16)+(g<<8)+b;

      r=(rgb>>16)&0xff;
      g=(rgb>>8)&0xff;
      b=(rgb)&0xff;
      r-=0x33;g-=0x33;b-=0x33;
      if(r<0) r=0;
      if(g<0) g=0;
      if(b<0) b=0;
      rgb2=(r<<16)+(g<<8)+b;

      pset(o,187-y,rgb1,vmem);
      pset(o+1,187-y,rgb1,vmem);
      for(x=0;x<6;x++)
        pset(o+2+x,187-y,rgb,vmem);
      pset(o+8,187-y,rgb2,vmem);
      pset(o+9,187-y,rgb2,vmem);
    }
  }
}

char *getname(int f)
{
  int i=0;
  int q=0;
  while(q==0)
  {
    if(f==tab_h[i]) q=1;
    i++;
    if(i>37) q=-1;
  }
  if(q==1) return tab_n[i-1];
  return tab_n[37];
}

int pt23_calcmodsize(pt_mod_s *ptmod)
{
  int i,j,m;
  int size;

  size=1084;
  m=0;
  for(i=0;i<128;i++)
  {
    j=ptmod->pos[i];
    if(j>m) m=j;
  }
  size+=(m+1)*1024;
  for(i=0;i<32;i++)
    size+=ptmod->sample[i].length>>14;

  return size;
}
