#include "pt23.h"
   
pt23_struct *pt23_init(void)
{
  pt23_struct *pt=0;


  pt=(pt23_struct *)calloc(1,sizeof(pt23_struct));
  pt->pt_tga=Load_TGA("data/pt2.tga");
  pt->ptfont_tga=Load_TGA("data/ptfont.tga");
  pt->ptpnt_tga=Load_TGA("data/pnt2.tga");
  pt->ptdisk_tga=Load_TGA("data/ptdisk2.tga");
  pt->ptsure_tga=Load_TGA("data/ptsure.tga");
  pt->ptcurs_tga=Load_TGA("data/ptcurs.tga");

  if(pt->pt_tga==0 || pt->ptfont_tga==0 || pt->ptpnt_tga==0 || pt->ptdisk_tga==0 || pt->ptsure_tga==0 || pt->ptcurs_tga==0)
  {
    pt23_free(pt);
    return 0;
  }

  pt->sample=1;
  return pt;
}

void pt23_free(pt23_struct *pt)
{
  if(pt==0) return;
  if(pt->pt_tga!=0)
  {
    free(pt->pt_tga->data);
    free(pt->pt_tga);
  }
  if(pt->ptfont_tga!=0)
  {
    free(pt->ptfont_tga->data);
    free(pt->ptfont_tga);
  }
  if(pt->ptpnt_tga!=0)
  {
    free(pt->ptpnt_tga->data);
    free(pt->ptpnt_tga);
  }
  if(pt->ptdisk_tga!=0)
  {
    free(pt->ptdisk_tga->data);
    free(pt->ptdisk_tga);
  }
  if(pt->ptsure_tga!=0)
  {
    free(pt->ptsure_tga->data);
    free(pt->ptsure_tga);
  }
  if(pt->ptcurs_tga!=0)
  {
    free(pt->ptcurs_tga->data);
    free(pt->ptcurs_tga);
  }
  free(pt);
}

void pt23_main(unsigned char *vmem,pt_mod_s *ptmod,pt23_struct *pt)
{
  pt_pattern_s *pat;
  int h,i,j,k,l,m;
  //char str[256];
  char ch;
  int avgvol[4];
  pt_sample_s *sampl;

  memcpy(vmem,pt->pt_tga->data,320*255*3);
  //pset(mx,my,0xf0d000,vmem);
  pt23_gfx_printchar(pt->mx,pt->my,'0',0,0x00ff00,(unsigned char *)pt->ptfont_tga->data,vmem);
  //prntstr(8,203,"01 ---00000 ---00000 ---00000 ---00000",(unsigned char *)ptfont_tga->data,vmem);
 

  pt23_gfx_printf(64,3,0,0x000000,vmem,pt,"%04d",ptmod->spos);

  pt23_gfx_printf(64,14,0,0x000000,vmem,pt,"%04d",ptmod->pos[ptmod->spos]);

  pt23_gfx_printf(8,127,0,0x000000,vmem,pt,"%02d",ptmod->pos[ptmod->spos]);

  pt23_gfx_printf(64,25,0,0x000000,vmem,pt,"%04d",ptmod->length);

  pt23_gfx_printf(32,123,0,0x000000,vmem,pt,"%03d",ptmod->ciaspeed);

  i=(int)(pt->time)%60;
  j=(int)(pt->time)/60;
  pt23_gfx_printf(272,102,0,0x000000,vmem,pt,"%02d %02d",j,i);

  for(i=0;i<20;i++)
  {
    ch=ptmod->name[i];
    if(ch!=0) 
      pt23_gfx_printchar(104+(i*8),102,ch,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
    else
      pt23_gfx_printchar(104+(i*8),102,'_',0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  }

  pt23_draw_main_up(vmem,ptmod,pt);

  j=0;
  for(m=0;m<4;m++)
  {
     avgvol[m]=0;
    for(i=0;i<40;i++)
    {
      k=ptmod->chan[m].sp;
      l=-1;
      if(ptmod->chan[m].sample!=0)
      {
        sampl=&ptmod->sample[ptmod->chan[m].sample];
        if(k>=0 && k < sampl->length)
        {
          l=k+(i<<14);
          if (sampl->replen > 32768)
          {
            if (l >= sampl->repend)
              l -= sampl->replen;
          }
          else
          {    
            if (l >= sampl->length)
              l=-1;
          }
        }
      }
      if(l==-1) 
        h=0;
      else
        h=(sampl->data[l>>14]*ptmod->chan[m].vol)>>6;
      if(abs(h)>avgvol[m]) avgvol[m]=abs(h);
      pt23_gfx_pset(128+(m*48)+i,71+(h/8),0xf0d000,vmem);
      j=h;
    }
  }


  //95,205
   pat=&ptmod->pattern[ptmod->pos[ptmod->cspos]];
  k=ptmod->cppos;
  j=k;
  pt23_gfx_printf(8,190,1,0x000000,vmem,pt,
    "%02d %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x",j,
    pt23_mod_period2name(pat->data[j][0].period),pat->data[j][0].sample,
    pat->data[j][0].effect,pat->data[j][0].efd1,pat->data[j][0].efd2,
    pt23_mod_period2name(pat->data[j][1].period),pat->data[j][1].sample,
    pat->data[j][1].effect,pat->data[j][1].efd1,pat->data[j][1].efd2,
    pt23_mod_period2name(pat->data[j][2].period),pat->data[j][2].sample,
    pat->data[j][2].effect,pat->data[j][2].efd1,pat->data[j][2].efd2,
    pt23_mod_period2name(pat->data[j][3].period),pat->data[j][3].sample,
    pat->data[j][3].effect,pat->data[j][3].efd1,pat->data[j][3].efd2);

  for(i=0;i<7;i++)
  {
    j=k-(7-i);
    if(j>=0 && j<64)
    {
      pt23_gfx_printf(8,140+(i*7),0,0x3344ff,vmem,pt,
        "%02d %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x",j,
        pt23_mod_period2name(pat->data[j][0].period),pat->data[j][0].sample,
        pat->data[j][0].effect,pat->data[j][0].efd1,pat->data[j][0].efd2,
        pt23_mod_period2name(pat->data[j][1].period),pat->data[j][1].sample,
        pat->data[j][1].effect,pat->data[j][1].efd1,pat->data[j][1].efd2,
        pt23_mod_period2name(pat->data[j][2].period),pat->data[j][2].sample,
        pat->data[j][2].effect,pat->data[j][2].efd1,pat->data[j][2].efd2,
        pt23_mod_period2name(pat->data[j][3].period),pat->data[j][3].sample,
        pat->data[j][3].effect,pat->data[j][3].efd1,pat->data[j][3].efd2);

    }
    j=k+i+1;
    if(j>=0 && j<64)
    {
      pt23_gfx_printf(8,203+(i*7),0,0x3344ff,vmem,pt,
        "%02d %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x %s%02d%x%x%x",j,
        pt23_mod_period2name(pat->data[j][0].period),pat->data[j][0].sample,
        pat->data[j][0].effect,pat->data[j][0].efd1,pat->data[j][0].efd2,
        pt23_mod_period2name(pat->data[j][1].period),pat->data[j][1].sample,
        pat->data[j][1].effect,pat->data[j][1].efd1,pat->data[j][1].efd2,
        pt23_mod_period2name(pat->data[j][2].period),pat->data[j][2].sample,
        pat->data[j][2].effect,pat->data[j][2].efd1,pat->data[j][2].efd2,
        pt23_mod_period2name(pat->data[j][3].period),pat->data[j][3].sample,
        pat->data[j][3].effect,pat->data[j][3].efd1,pat->data[j][3].efd2);
    }
  }

  pt23_draw_vumeter((int)(avgvol[0]/2.6),(int)(avgvol[1]/2.6),(int)(avgvol[2]/2.6),(int)(avgvol[3]/2.6),vmem);
 
  pt23_draw_cursor(vmem,pt);

  pt23_gfx_printf(264,123,0,0x000000,vmem,pt,"%6d",pt->modsize);

  if(pt->mb & 1)
    pt->lmb++;
  else
    pt->lmb=0;

  if(pt->mb & 2)
    pt->rmb++;
  else
    pt->rmb=0;

  pt->b=pt23_input_checkbuttons(pt);
  switch(pt->b)
  {
  case PTB_DISKOP:
    pt->mode=1;
    break;
  case PTB_SAMPLEU:
    pt->sample++;
    if(pt->sample>31) pt->sample=31;
    break;
  case PTB_SAMPLED:
      pt->sample--;
      if(pt->sample<1) pt->sample=1;
      break;
  case PTB_POSU:
    ptmod->spos++;
    if(ptmod->spos>127) ptmod->spos=127;
    break;
  case PTB_POSD:
    ptmod->spos--;
    if(ptmod->spos<0) ptmod->spos=0;
    break;
  case PTB_TEMPOU:
    if(pt->rmb!=0) ptmod->ciaspeed+=10; else ptmod->ciaspeed++;
    if(ptmod->ciaspeed>255) ptmod->ciaspeed=255;
    ptmod->vbllen=ptmod->freq * 60 / (24 * ptmod->ciaspeed);
    break;
  case PTB_TEMPOD:
    if(pt->rmb!=0) ptmod->ciaspeed-=10; else ptmod->ciaspeed--;
    if(ptmod->ciaspeed<32) ptmod->ciaspeed=32;
    ptmod->vbllen=ptmod->freq * 60 / (24 * ptmod->ciaspeed);
    break;
  case PTB_PLAY:
    ptmod->state=PT_STATE_PLAYSONG;
    ptmod->ppos=0;
    break;
  case PTB_STOP:
    ptmod->state=PT_STATE_STOP;
    for(i=0;i<4;i++)
    {
      ptmod->chan[i].sample=0;
    }
    break;
  case PTB_PATTERN:
    ptmod->state=PT_STATE_PLAYPATTERN;
	ptmod->ppos=0;
    break;
  case PTB_SVOLUMEU:
    ptmod->sample[pt->sample].volume++;
    if(ptmod->sample[pt->sample].volume>0x40) ptmod->sample[pt->sample].volume=0x40;
    break;
  case PTB_SVOLUMED:
    ptmod->sample[pt->sample].volume--;
    if(ptmod->sample[pt->sample].volume<0) ptmod->sample[pt->sample].volume=0;
    break;
  case PTB_CLEAR:
	  for(i=0;i<64;i++)
		  for(j=0;j<4;j++)
		  {
			  ptmod->pattern[ptmod->pos[ptmod->cspos]].data[i][j].period=0;
			  ptmod->pattern[ptmod->pos[ptmod->cspos]].data[i][j].sample=0;
			  ptmod->pattern[ptmod->pos[ptmod->cspos]].data[i][j].efboth=0;
			  ptmod->pattern[ptmod->pos[ptmod->cspos]].data[i][j].efd1=0;
			  ptmod->pattern[ptmod->pos[ptmod->cspos]].data[i][j].efd2=0;
			  ptmod->pattern[ptmod->pos[ptmod->cspos]].data[i][j].effect=0;		  
		  }
  };

  if(pt->mode==1)
  {
    memcpy(vmem,pt->ptdisk_tga->data,320*99*3);
  }

  if(pt->quit==1)
    pt23_draw_areyousurereq(vmem,pt);

  pt23_draw_pointer(pt->mx,pt->my,pt->ptpnt_tga->data,vmem);
}

