#ifndef PT23_H
#define PT23_H

#include "../kgl/tga.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "../ptplay/ptplay.h"

int pt23_cursorpos_tab[];
char pt23_name_tab[][4];
int pt23_period_tab[];
int pt23_defaultvucolors[];

typedef struct
{
  int x1,y1,x2,y2;
} pt23_button_s;

pt23_button_s pt23_buttons[];

enum pt23_button_names{
  PTB_SUREY,PTB_SUREN,
  PTB_PLAY,PTB_PATTERN,PTB_EDIT,PTB_RECORD,
  PTB_STOP,PTB_CLEAR,PTB_EDITOP,PTB_DISKOP,
  PTB_PLST,PTB_PSETED,PTB_SETUP,PTB_SAMPLER,
  PTB_CHAN1,PTB_CHAN2,PTB_CHAN3,PTB_CHAN4,
  PTB_POSS,PTB_POSU,PTB_POSD,
  PTB_PATTERNS,PTB_PATTERNU,PTB_PATTERND,
  PTB_PLENGTHS,PTB_PLENGTHU,PTB_PLENGTHD,
  PTB_FTUNES,PTB_FTUNEU,PTB_FTUNED,
  PTB_SAMPLES,PTB_SAMPLEU,PTB_SAMPLED,
  PTB_SVOLUMES,PTB_SVOLUMEU,PTB_SVOLUMED,
  PTB_SLENGTHS,PTB_SLENGTHU,PTB_SLENGTHD,
  PTB_SREPEATS,PTB_SREPEATU,PTB_SREPEATD,
  PTB_SREPLENS,PTB_SREPLENU,SREPLEND,
  PTB_TEMPOU,PTB_TEMPOD,
  PTB_NUMBUTTONS
};


//#include "pt23_tables.h"


typedef struct
{
  tImageTGA *pt_tga;
  tImageTGA *ptfont_tga;
  tImageTGA *ptpnt_tga;
  tImageTGA *ptdisk_tga;
  tImageTGA *ptsure_tga;
  tImageTGA *ptcurs_tga;
  int time;
  int mx,my; 
  int mb;
  int lmb,rmb;
  int mode;
  int b;
  int sample;
  int modsize;
  int quit;
  int cursx,cursy;
  int curs_chan,curs_pos;

} pt23_struct;


pt23_struct *pt23_init(void);
void pt23_free(pt23_struct *pt);
void pt23_main(unsigned char *vmem,pt_mod_s *ptmod,pt23_struct *pt);


void pt23_gfx_printchar(int x,int y,char c,int s,int rgb,unsigned char *font,unsigned char *vmem);
void pt23_gfx_printstr(int x,int y,char *str,int s,int rgb,unsigned char *font,unsigned char *vmem);
void pt23_gfx_printf(int x,int y,int s,int rgb,unsigned char *vmem,pt23_struct *pt,const char *fmt, ...);
void pt23_gfx_pset(int x,int y,int rgb,unsigned char *vmem);

char *pt23_mod_period2name(int f);
int pt23_mod_getmodsize(pt_mod_s *ptmod);

void pt23_draw_areyousurereq(unsigned char *vmem,pt23_struct *pt);
void pt23_draw_cursor(unsigned char *vmem,pt23_struct *pt);
void pt23_draw_main_up(unsigned char *vmem,pt_mod_s *ptmod,pt23_struct *pt);
void pt23_draw_pointer(int x,int y,unsigned char *p,unsigned char *vmem);
void pt23_draw_vumeter(int v1,int v2,int v3,int v4,unsigned char *vmem);

int pt23_input_checkbutton(int mx,int my,int b);
int pt23_input_checkbuttons(pt23_struct *pt);

#endif