// draw pt23 user interface

#include "pt23.h"

void pt23_draw_areyousurereq(unsigned char *vmem,pt23_struct *pt)
{
  int x,y;
  int ox=160;
  int oy=51;
  int o,ov;
  for(y=0;y<pt->ptsure_tga->size_y;y++)
    for(x=0;x<pt->ptsure_tga->size_x;x++)
    {
      ov=(320*(y+oy)+(x+ox))*3;
      o=(y*pt->ptsure_tga->size_x+x)*3;
      vmem[ov+0]=pt->ptsure_tga->data[o+0];
      vmem[ov+1]=pt->ptsure_tga->data[o+1];
      vmem[ov+2]=pt->ptsure_tga->data[o+2];
    }
}

void pt23_draw_cursor(unsigned char *vmem,pt23_struct *pt)
{
  int x,y;
  int ox;
  int oy;
  int o,ov;

  oy=188;
  ox=pt23_cursorpos_tab[pt->curs_chan*6+pt->curs_pos];
  for(y=0;y<pt->ptcurs_tga->size_y;y++)
    for(x=0;x<pt->ptcurs_tga->size_x;x++)
    {
      ov=(320*(y+oy)+(x+ox))*3;
      o=(y*pt->ptcurs_tga->size_x+x)*3;
      if(pt->ptcurs_tga->data[o+0]!=0)
      {
      vmem[ov+0]=pt->ptcurs_tga->data[o+0];
      vmem[ov+1]=pt->ptcurs_tga->data[o+1];
      vmem[ov+2]=pt->ptcurs_tga->data[o+2];
      }
    }
}

void pt23_draw_main_up(unsigned char *vmem,pt_mod_s *ptmod,pt23_struct *pt)
{
  int i;
  char ch;
  //char str[256];


  for(i=0;i<22;i++)
  {
    ch=ptmod->sample[pt->sample].name[i];
    if(ch!=0) 
      pt23_gfx_printchar(104+(i*8),113,ch,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
    else
      pt23_gfx_printchar(104+(i*8),113,'_',0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
  }
  

  pt23_gfx_printf(64,47,0,0x000000,vmem,pt,"%04x",pt->sample);
  pt23_gfx_printf(64,58,0,0x000000,vmem,pt,"%04x",ptmod->sample[pt->sample].volume);
  pt23_gfx_printf(64,69,0,0x000000,vmem,pt,"%04x",ptmod->sample[pt->sample].length>>14);
  pt23_gfx_printf(64,80,0,0x000000,vmem,pt,"%04x",ptmod->sample[pt->sample].repeat>>14);
  pt23_gfx_printf(64,91,0,0x000000,vmem,pt,"%04x",ptmod->sample[pt->sample].replen>>14);
  
  i=ptmod->sample[pt->sample].ft;
  ch='+';
  if(i>8){
    ch='-';
    i=(8-(i-8));
  }
  if(i==0) ch=' ';
  pt23_gfx_printf(88,36,0,0x000000,vmem,pt,"%x",i);
  pt23_gfx_printchar(80,36,ch,0,0x000000,(unsigned char *)pt->ptfont_tga->data,vmem);
}

void pt23_draw_pointer(int x,int y,unsigned char *p,unsigned char *vmem)
{
  int xx,yy;
  int ox,oy;
  int cr,cg,cb;

  cr=0x11;
  cg=0x11;
  cb=0xff;

  for(yy=0;yy<16;yy++)
    for(xx=0;xx<16;xx++)
    {
      ox=xx+x;
      oy=yy+y;
      if(ox>=0 && ox<=319 && oy>=0 && oy<=254)
      {
        if(p[(yy*16+xx)*3+0]!=0)
        {
          vmem[(oy*320+ox)*3+0]=((int)p[(yy*16+xx)*3+0]*cr)>>8;
          vmem[(oy*320+ox)*3+1]=((int)p[(yy*16+xx)*3+1]*cg)>>8;
          vmem[(oy*320+ox)*3+2]=((int)p[(yy*16+xx)*3+2]*cb)>>8;
        }
      }

    }



}


void pt23_draw_vumeter(int v1,int v2,int v3,int v4,unsigned char *vmem)
{
  int r,g,b;
  int rgb;
  int rgb1,rgb2;
  int vu[4];
  int c,o;
  int x,y;

  vu[0]=v1;vu[1]=v2;vu[2]=v3;vu[3]=v4;

  //55+72*i;
  for(c=0;c<4;c++)
  {
    o=55+72*c;
    for(y=0;y<vu[c];y++)
    {
      rgb=pt23_defaultvucolors[47-y];
      r=(rgb>>16)&0xff;
      g=(rgb>>8)&0xff;
      b=(rgb)&0xff;
      r+=0x33;g+=0x33;b+=0x33;
      if(r>0xff) r=0xff;
      if(g>0xff) g=0xff;
      if(b>0xff) b=0xff;
      rgb1=(r<<16)+(g<<8)+b;

      r=(rgb>>16)&0xff;
      g=(rgb>>8)&0xff;
      b=(rgb)&0xff;
      r-=0x33;g-=0x33;b-=0x33;
      if(r<0) r=0;
      if(g<0) g=0;
      if(b<0) b=0;
      rgb2=(r<<16)+(g<<8)+b;

      pt23_gfx_pset(o,187-y,rgb1,vmem);
      pt23_gfx_pset(o+1,187-y,rgb1,vmem);
      for(x=0;x<6;x++)
        pt23_gfx_pset(o+2+x,187-y,rgb,vmem);
      pt23_gfx_pset(o+8,187-y,rgb2,vmem);
      pt23_gfx_pset(o+9,187-y,rgb2,vmem);
    }
  }
}