// lowlevel gfx routines

#include "pt23.h"



void pt23_gfx_printchar(int x,int y,char c,int s,int rgb,unsigned char *font,unsigned char *vmem)
{
  int o;
  int ox,oy;
  int xx,yy;
  int r,g,b;
  if(c>96) c-=32;
  o=c-32;
  if(o<0 || o>71) return;
  o*=8;
  if(x<0 || y<0 || x>312 || y>247) return;
  if(s==1 && y>239) return;
  r=(rgb>>16)&0xff;
  g=(rgb>>8)&0xff;
  b=(rgb)&0xff;
  for(yy=0;yy<8;yy++)
    for(xx=0;xx<8;xx++)
    {
      ox=xx+x;
      oy=yy+y;
      if(s==1){oy=yy*2+y;}
      if(font[((o+yy)*8+xx)*4]!=0)
      {
        if(s==1)
        {
          vmem[(oy*320+ox)*3+0]=r;
          vmem[(oy*320+ox)*3+1]=g;
          vmem[(oy*320+ox)*3+2]=b;
          vmem[((oy+1)*320+ox)*3+0]=r;
          vmem[((oy+1)*320+ox)*3+1]=g;
          vmem[((oy+1)*320+ox)*3+2]=b;
        }
        else
        {
          vmem[(oy*320+ox)*3+0]=r;
          vmem[(oy*320+ox)*3+1]=g;
          vmem[(oy*320+ox)*3+2]=b;
        }
      }

    }
}

void pt23_gfx_printstr(int x,int y,char *str,int s,int rgb,unsigned char *font,unsigned char *vmem)
{
  int l;
  int i;

  l=strlen(str);
  for(i=0;i<l;i++)
    pt23_gfx_printchar(x+(i*8),y,str[i],s,rgb,font,vmem);
}

void pt23_gfx_printf(int x,int y,int s,int rgb,unsigned char *vmem,pt23_struct *pt,const char *fmt, ...)
{
  char text[512];
  va_list		ap;

  if (fmt == NULL)								
		return;										

	va_start(ap, fmt);									
	    vsprintf(text, fmt, ap);
	va_end(ap);

  pt23_gfx_printstr(x,y,text,s,rgb,pt->ptfont_tga->data,vmem);
}

void pt23_gfx_pset(int x,int y,int rgb,unsigned char *vmem)
{
  unsigned char r,g,b;
  r=(rgb>>16)&0xff;
  g=(rgb>>8)&0xff;
  b=(rgb)&0xff;

  vmem[(y*320+x)*3+0]=r;
  vmem[(y*320+x)*3+1]=g;
  vmem[(y*320+x)*3+2]=b;
}
