
#include <string.h>
#include "tek_global.h"

TAPTR TExecBase;
TAPTR TUtilBase;
TAPTR TTimeBase;
TAPTR TImgpBase;
TAPTR TDispBase;
TAPTR TDthBase;
TAPTR TIOBase;

TAPTR TimeRequest;
TAPTR ArgHandle = TNULL;
TAPTR Arguments[ARG_NUM];

/******************************************************************************/

TBOOL
g_init(TAPTR task)
{
	TExecBase = TGetExecBase(task);
	TUtilBase = TExecOpenModule(TExecBase, "util", 0, TNULL);
	TTimeBase = TExecOpenModule(TExecBase, "time", 0, TNULL);
	TImgpBase = TExecOpenModule(TExecBase, "imgproc", 0, TNULL);
	TDispBase = TExecOpenModule(TExecBase, "displayhandler", 0, TNULL);
	TDthBase = TExecOpenModule(TExecBase, "datatypehandler", 0, TNULL);
	TIOBase = TExecOpenModule(TExecBase, "io", 0, TNULL);

	if (TUtilBase && TTimeBase && TImgpBase && TDispBase && TDthBase && TIOBase)
	{
		TimeRequest = TTimeAllocRequest(TTimeBase, TNULL);
		if (TimeRequest)
		{
			TSTRPTR *argv = TUtilGetArgV(TUtilBase);
			memset(Arguments, 0, sizeof(Arguments));

			/* Insert some defaults */
			Arguments[ARG_FILENAME] = DEFAULT_MODULE;

			ArgHandle = TUtilParseArgV(TUtilBase, ARG_TEMPLATE, argv + 1, Arguments);
			if (ArgHandle == TNULL || Arguments[ARG_HELP])
			{
				printf("FILE            : Module filename\n");
				printf("-f=FULLSCREEN/S : Open fullscreen display\n");
				printf("-s=BUFSIZE/N    : Audio buffer size [Number of samples]\n");
				printf("-h=HELP/S       : This help\n");
			}
			else
			{
				return TTRUE;
			}
		}
	}

	g_exit();
	return TFALSE;
}

TVOID
g_exit(TVOID)
{
	TDestroy(ArgHandle);
	TExecCloseModule(TExecBase, TIOBase);
	TExecCloseModule(TExecBase, TDispBase);
	TExecCloseModule(TExecBase, TDthBase);
	TExecCloseModule(TExecBase, TImgpBase);
	if (TTimeBase)
	{
		TTimeFreeRequest(TTimeBase, TimeRequest);
		TExecCloseModule(TExecBase, TTimeBase);
	}
	TExecCloseModule(TExecBase, TUtilBase);
}
