
#include "tek_global.h"
#include "tek_tga.h"

tImageTGA *
Load_TGA(const char *filename)
{
	tImageTGA *img = TExecAlloc(TExecBase, TNULL, sizeof(tImageTGA));
	if (img)
	{
		if (tLoadImage(&img->realImage, (TSTRPTR) filename))
		{
			img->channels = 3;
			img->size_x = img->realImage.pic.width;
			img->size_y = img->realImage.pic.height;
			img->data = img->realImage.pic.data;
			return img;
		}
		TExecFree(TExecBase, img);
	}
	return TNULL;
}

void
Free_TGA(tImageTGA *img)
{
	if (img)
	{
		tFreeImage(&img->realImage);
		TExecFree(TExecBase, img);
	}
}
