
#ifndef _PTREPLAY_H
#define _PTREPLAY_H

/*
**	protracker 2.3a player
**	(C) 2001, 2003 Ronald Hof and Timm S. Mueller
*/

#ifdef AMIGA
	#include <exec/types.h>
#else
	typedef signed char BYTE;
	typedef unsigned char UBYTE;
	typedef signed short WORD;
	typedef unsigned short UWORD;
	typedef signed int LONG;
	typedef unsigned int ULONG;
	#ifndef TRUE
	#define	TRUE 1
	#endif
	#ifndef FALSE
	#define	FALSE 0
	#endif
	#ifndef NULL
	#define	NULL 0
	#endif
#endif

#ifndef LIBAPI
#define LIBAPI
#endif

#define MODF_DOSONGEND		0x0001		/* perform song-end detection */
#define MODF_ALLOWPANNING	0x0002		/* allow mod to use command $8 for panning */
#define MODF_ALLOWFILTER	0x0004		/* allow mod to set lowpass filter */
#define MODF_SONGEND		0x0008		/* songend occured */

struct Sample
{
	BYTE *data;
	LONG length, repeat, replen, repend;		/* <<14, includes oversampling precision */
	LONG ft;
	LONG volume;
	LONG pad;
};	/* 32 bytes */

struct Channel
{
	LONG sample, sp, per, freq, oldsp;
	LONG dp, basevol, vol, dvol, pan, ft;
	ULONG flags;
	LONG dtp, tptarget;
	LONG retrig, cutoff, delay;
	LONG arp, arpbase;
	LONG vibspeed, vibdepth, avibspeed, avibindex;
	LONG trespeed, tredepth, atrespeed, atreindex;
	LONG vibwave, tremwave, glissando;
	LONG delaysample;
	LONG loopstart, loopcount;
};

struct PatternData
{
	LONG period, sample;
	UBYTE effect, efd1, efd2, efboth;
	LONG pad;
};	/* 16 bytes */

struct Pattern
{
	struct PatternData data[64][4];
};

struct PlayMod
{
	struct Sample sample[32];
	struct Channel chan[4];
	LONG pos[128];
	char name[32];
	struct Pattern *pattern;
	ULONG flags;
	LONG numpat;
	LONG length;
	LONG freq;
	LONG mastervolume;
	LONG spos, ppos, speed, ciaspeed, vbllen, bpos, tick;
	LONG patdelay, skiptopos, filter;
	LONG songloopcount;
	FLOAT flta, fltb;
	FLOAT fltpi[4];
	FLOAT fltpo[4];
}; 

LIBAPI ULONG pt_init(struct PlayMod *pmod, UBYTE *buf, LONG bufsize, LONG freq);
LIBAPI void pt_render(struct PlayMod *pmod, BYTE *buf, BYTE *buf2, LONG bufmodulo, LONG numsmp, LONG scale, LONG depth, LONG channels);

#endif
